diff --git a/gcc/tree-vect-slp.c b/gcc/tree-vect-slp.c
index 0ab267f..9a79261 100644
--- a/gcc/tree-vect-slp.c
+++ b/gcc/tree-vect-slp.c
@@ -54,7 +54,7 @@ along with GCC; see the file COPYING3.  If not see
 source_location
 find_bb_location (basic_block bb)
 {
-  gimple stmt = NULL;
+  gimple *stmt = NULL;
   gimple_stmt_iterator si;
 
   if (!bb)
@@ -109,10 +109,10 @@ vect_free_slp_instance (slp_instance instance)
 /* Create an SLP node for SCALAR_STMTS.  */
 
 static slp_tree
-vect_create_new_slp_node (vec<gimple> scalar_stmts)
+vect_create_new_slp_node (vec<gimple *> scalar_stmts)
 {
   slp_tree node;
-  gimple stmt = scalar_stmts[0];
+  gimple *stmt = scalar_stmts[0];
   unsigned int nops;
 
   if (is_gimple_call (stmt))
@@ -182,9 +182,9 @@ vect_free_oprnd_info (vec<slp_oprnd_info> &oprnds_info)
    from FIRST_STMT.  Return -1 if the data-ref is not a part of the chain.  */
 
 static int
-vect_get_place_in_interleaving_chain (gimple stmt, gimple first_stmt)
+vect_get_place_in_interleaving_chain (gimple *stmt, gimple *first_stmt)
 {
-  gimple next_stmt = first_stmt;
+  gimple *next_stmt = first_stmt;
   int result = 0;
 
   if (first_stmt != GROUP_FIRST_ELEMENT (vinfo_for_stmt (stmt)))
@@ -209,13 +209,13 @@ vect_get_place_in_interleaving_chain (gimple stmt, gimple first_stmt)
 
 static bool
 vect_get_and_check_slp_defs (loop_vec_info loop_vinfo, bb_vec_info bb_vinfo,
-                             gimple stmt, bool first,
+                             gimple *stmt, bool first,
                              vec<slp_oprnd_info> *oprnds_info)
 {
   tree oprnd;
   unsigned int i, number_of_oprnds;
   tree def;
-  gimple def_stmt;
+  gimple *def_stmt;
   enum vect_def_type dt = vect_uninitialized_def;
   struct loop *loop = NULL;
   bool pattern = false;
@@ -399,12 +399,12 @@ vect_get_and_check_slp_defs (loop_vec_info loop_vinfo, bb_vec_info bb_vinfo,
 
 static bool
 vect_build_slp_tree_1 (loop_vec_info loop_vinfo, bb_vec_info bb_vinfo,
-		       vec<gimple> stmts, unsigned int group_size,
+		       vec<gimple *> stmts, unsigned int group_size,
 		       unsigned nops, unsigned int *max_nunits,
 		       unsigned int vectorization_factor, bool *matches)
 {
   unsigned int i;
-  gimple stmt = stmts[0];
+  gimple *stmt = stmts[0];
   enum tree_code first_stmt_code = ERROR_MARK, rhs_code = ERROR_MARK;
   enum tree_code first_cond_code = ERROR_MARK;
   tree lhs;
@@ -416,7 +416,7 @@ vect_build_slp_tree_1 (loop_vec_info loop_vinfo, bb_vec_info bb_vinfo,
   enum machine_mode vec_mode;
   struct data_reference *first_dr;
   HOST_WIDE_INT dummy;
-  gimple first_load = NULL, prev_first_load = NULL, old_first_load = NULL;
+  gimple *first_load = NULL, *prev_first_load = NULL, *old_first_load = NULL;
   tree cond;
 
   /* For every stmt in NODE find its def stmt/s.  */
@@ -630,7 +630,7 @@ vect_build_slp_tree_1 (loop_vec_info loop_vinfo, bb_vec_info bb_vinfo,
 
 	  if (rhs_code == CALL_EXPR)
 	    {
-	      gimple first_stmt = stmts[0];
+	      gimple *first_stmt = stmts[0];
 	      if (gimple_call_num_args (stmt) != nops
 		  || !operand_equal_p (gimple_call_fn (first_stmt),
 				       gimple_call_fn (stmt), 0)
@@ -853,7 +853,7 @@ vect_build_slp_tree (loop_vec_info loop_vinfo, bb_vec_info bb_vinfo,
 		     unsigned max_tree_size)
 {
   unsigned nops, i, this_npermutes = 0, this_tree_size = 0;
-  gimple stmt;
+  gimple *stmt;
 
   if (!matches)
     matches = XALLOCAVEC (bool, group_size);
@@ -961,7 +961,7 @@ vect_build_slp_tree (loop_vec_info loop_vinfo, bb_vec_info bb_vinfo,
 	  for (unsigned j = 0; j < group_size; ++j)
 	    if (!matches[j])
 	      {
-		gimple tem = oprnds_info[0]->def_stmts[j];
+		gimple *tem = oprnds_info[0]->def_stmts[j];
 		oprnds_info[0]->def_stmts[j] = oprnds_info[1]->def_stmts[j];
 		oprnds_info[1]->def_stmts[j] = tem;
 	      }
@@ -999,7 +999,7 @@ static void
 vect_print_slp_tree (int dump_kind, slp_tree node)
 {
   int i;
-  gimple stmt;
+  gimple *stmt;
   slp_tree child;
 
   if (!node)
@@ -1027,7 +1027,7 @@ static void
 vect_mark_slp_stmts (slp_tree node, enum slp_vect_type mark, int j)
 {
   int i;
-  gimple stmt;
+  gimple *stmt;
   slp_tree child;
 
   if (!node)
@@ -1048,7 +1048,7 @@ static void
 vect_mark_slp_stmts_relevant (slp_tree node)
 {
   int i;
-  gimple stmt;
+  gimple *stmt;
   stmt_vec_info stmt_info;
   slp_tree child;
 
@@ -1074,8 +1074,8 @@ static void
 vect_slp_rearrange_stmts (slp_tree node, unsigned int group_size,
                           vec<unsigned> permutation)
 {
-  gimple stmt;
-  vec<gimple> tmp_stmts;
+  gimple *stmt;
+  vec<gimple *> tmp_stmts;
   unsigned int i;
   slp_tree child;
 
@@ -1104,7 +1104,7 @@ vect_supported_load_permutation_p (slp_instance slp_instn)
   unsigned int i, j, k, next;
   sbitmap load_index;
   slp_tree node;
-  gimple stmt, load, next_load, first_load;
+  gimple *stmt, *load, *next_load, *first_load;
   struct data_reference *dr;
 
   if (dump_enabled_p ())
@@ -1294,12 +1294,12 @@ vect_supported_load_permutation_p (slp_instance slp_instn)
    they must be inserted before the first load of the SLP instance and not
    before the first load of the first node of the instance.  */
 
-static gimple
+static gimple *
 vect_find_first_load_in_slp_instance (slp_instance instance)
 {
   int i, j;
   slp_tree load_node;
-  gimple first_load = NULL, load;
+  gimple *first_load = NULL, *load;
 
   FOR_EACH_VEC_ELT (SLP_INSTANCE_LOADS (instance), i, load_node)
     FOR_EACH_VEC_ELT (SLP_TREE_SCALAR_STMTS (load_node), j, load)
@@ -1311,12 +1311,12 @@ vect_find_first_load_in_slp_instance (slp_instance instance)
 
 /* Find the last store in SLP INSTANCE.  */
 
-static gimple
+static gimple *
 vect_find_last_store_in_slp_instance (slp_instance instance)
 {
   int i;
   slp_tree node;
-  gimple last_store = NULL, store;
+  gimple *last_store = NULL, *store;
 
   node = SLP_INSTANCE_TREE (instance);
   for (i = 0; SLP_TREE_SCALAR_STMTS (node).iterate (i, &store); i++)
@@ -1337,7 +1337,7 @@ vect_analyze_slp_cost_1 (loop_vec_info loop_vinfo, bb_vec_info bb_vinfo,
 
   unsigned i;
   slp_tree child;
-  gimple stmt, s;
+  gimple *stmt, *s;
   stmt_vec_info stmt_info;
   tree lhs;
   unsigned group_size = SLP_INSTANCE_GROUP_SIZE (instance);
@@ -1390,7 +1390,7 @@ vect_analyze_slp_cost_1 (loop_vec_info loop_vinfo, bb_vec_info bb_vinfo,
   for (i = 0; i < gimple_num_ops (stmt); ++i)
     {
       tree def, op = gimple_op (stmt, i);
-      gimple def_stmt;
+      gimple *def_stmt;
       enum vect_def_type dt;
       if (!op || op == lhs)
 	continue;
@@ -1448,20 +1448,20 @@ vect_analyze_slp_cost (loop_vec_info loop_vinfo, bb_vec_info bb_vinfo,
 
 static bool
 vect_analyze_slp_instance (loop_vec_info loop_vinfo, bb_vec_info bb_vinfo,
-                           gimple stmt, unsigned max_tree_size)
+                           gimple *stmt, unsigned max_tree_size)
 {
   slp_instance new_instance;
   slp_tree node;
   unsigned int group_size = GROUP_SIZE (vinfo_for_stmt (stmt));
   unsigned int unrolling_factor = 1, nunits;
   tree vectype, scalar_type = NULL_TREE;
-  gimple next;
+  gimple *next;
   unsigned int vectorization_factor = 0;
   int i;
   unsigned int max_nunits = 0;
   vec<slp_tree> loads;
   struct data_reference *dr = STMT_VINFO_DATA_REF (vinfo_for_stmt (stmt));
-  vec<gimple> scalar_stmts;
+  vec<gimple *> scalar_stmts;
 
   if (GROUP_FIRST_ELEMENT (vinfo_for_stmt (stmt)))
     {
@@ -1536,7 +1536,7 @@ vect_analyze_slp_instance (loop_vec_info loop_vinfo, bb_vec_info bb_vinfo,
   else
     {
       /* Collect reduction statements.  */
-      vec<gimple> reductions = LOOP_VINFO_REDUCTIONS (loop_vinfo);
+      vec<gimple *> reductions = LOOP_VINFO_REDUCTIONS (loop_vinfo);
       for (i = 0; reductions.iterate (i, &next); i++)
 	scalar_stmts.safe_push (next);
     }
@@ -1583,7 +1583,7 @@ vect_analyze_slp_instance (loop_vec_info loop_vinfo, bb_vec_info bb_vinfo,
 	{
 	  vec<unsigned> load_permutation;
 	  int j;
-	  gimple load, first_stmt;
+	  gimple *load, *first_stmt;
 	  bool this_load_permuted = false;
 	  load_permutation.create (group_size);
 	  first_stmt = GROUP_FIRST_ELEMENT
@@ -1658,10 +1658,10 @@ vect_analyze_slp (loop_vec_info loop_vinfo, bb_vec_info bb_vinfo,
 		  unsigned max_tree_size)
 {
   unsigned int i;
-  vec<gimple> grouped_stores;
-  vec<gimple> reductions = vNULL;
-  vec<gimple> reduc_chains = vNULL;
-  gimple first_element;
+  vec<gimple *> grouped_stores;
+  vec<gimple *> reductions = vNULL;
+  vec<gimple *> reduc_chains = vNULL;
+  gimple *first_element;
   bool ok = false;
 
   if (dump_enabled_p ())
@@ -1764,10 +1764,10 @@ static void
 vect_detect_hybrid_slp_stmts (slp_tree node)
 {
   int i;
-  vec<gimple> stmts = SLP_TREE_SCALAR_STMTS (node);
-  gimple stmt = stmts[0];
+  vec<gimple *> stmts = SLP_TREE_SCALAR_STMTS (node);
+  gimple *stmt = stmts[0];
   imm_use_iterator imm_iter;
-  gimple use_stmt;
+  gimple *use_stmt;
   stmt_vec_info stmt_vinfo = vinfo_for_stmt (stmt);
   slp_tree child;
   loop_vec_info loop_vinfo = STMT_VINFO_LOOP_VINFO (stmt_vinfo);
@@ -1836,7 +1836,7 @@ new_bb_vec_info (basic_block bb)
 
   for (gsi = gsi_start_bb (bb); !gsi_end_p (gsi); gsi_next (&gsi))
     {
-      gimple stmt = gsi_stmt (gsi);
+      gimple *stmt = gsi_stmt (gsi);
       gimple_set_uid (stmt, 0);
       set_vinfo_for_stmt (stmt, new_stmt_vec_info (stmt, NULL, res));
     }
@@ -1869,7 +1869,7 @@ destroy_bb_vec_info (bb_vec_info bb_vinfo)
 
   for (si = gsi_start_bb (bb); !gsi_end_p (si); gsi_next (&si))
     {
-      gimple stmt = gsi_stmt (si);
+      gimple *stmt = gsi_stmt (si);
       stmt_vec_info stmt_info = vinfo_for_stmt (stmt);
 
       if (stmt_info)
@@ -1898,7 +1898,7 @@ vect_slp_analyze_node_operations (bb_vec_info bb_vinfo, slp_tree node)
 {
   bool dummy;
   int i;
-  gimple stmt;
+  gimple *stmt;
   slp_tree child;
 
   if (!node)
@@ -1961,7 +1961,7 @@ vect_bb_slp_scalar_cost (basic_block bb,
 {
   unsigned scalar_cost = 0;
   unsigned i;
-  gimple stmt;
+  gimple *stmt;
   slp_tree child;
 
   FOR_EACH_VEC_ELT (SLP_TREE_SCALAR_STMTS (node), i, stmt)
@@ -1982,7 +1982,7 @@ vect_bb_slp_scalar_cost (basic_block bb,
       FOR_EACH_SSA_DEF_OPERAND (def_p, stmt, op_iter, SSA_OP_DEF)
 	{
 	  imm_use_iterator use_iter;
-	  gimple use_stmt;
+	  gimple *use_stmt;
 	  FOR_EACH_IMM_USE_STMT (use_stmt, use_iter, DEF_FROM_PTR (def_p))
 	    if (!is_gimple_debug (use_stmt)
 		&& (gimple_code (use_stmt) == GIMPLE_PHI
@@ -2240,7 +2240,7 @@ vect_slp_analyze_bb (basic_block bb)
 
   for (gsi = gsi_start_bb (bb); !gsi_end_p (gsi); gsi_next (&gsi))
     {
-      gimple stmt = gsi_stmt (gsi);
+      gimple *stmt = gsi_stmt (gsi);
       if (!is_gimple_debug (stmt)
           && !gimple_nop_p (stmt)
           && gimple_code (stmt) != GIMPLE_LABEL)
@@ -2336,8 +2336,8 @@ vect_get_constant_vectors (tree op, slp_tree slp_node,
 			   unsigned int op_num, unsigned int number_of_vectors,
                            int reduc_index)
 {
-  vec<gimple> stmts = SLP_TREE_SCALAR_STMTS (slp_node);
-  gimple stmt = stmts[0];
+  vec<gimple *> stmts = SLP_TREE_SCALAR_STMTS (slp_node);
+  gimple *stmt = stmts[0];
   stmt_vec_info stmt_vinfo = vinfo_for_stmt (stmt);
   unsigned nunits;
   tree vec_cst;
@@ -2353,7 +2353,7 @@ vect_get_constant_vectors (tree op, slp_tree slp_node,
   bool constant_p, is_store;
   tree neutral_op = NULL;
   enum tree_code code = gimple_expr_code (stmt);
-  gimple def_stmt;
+  gimple *def_stmt;
   struct loop *loop;
   gimple_seq ctor_seq = NULL;
 
@@ -2526,7 +2526,7 @@ vect_get_constant_vectors (tree op, slp_tree slp_node,
 		{
 		  tree new_temp
 		    = make_ssa_name (TREE_TYPE (vector_type), NULL);
-		  gimple init_stmt;
+		  gimple *init_stmt;
 		  op = build1 (VIEW_CONVERT_EXPR, TREE_TYPE (vector_type),
 			       op);		  
 		  init_stmt
@@ -2559,7 +2559,7 @@ vect_get_constant_vectors (tree op, slp_tree slp_node,
 						    vector_type, NULL));
 	      if (ctor_seq != NULL)
 		{
-		  gimple init_stmt = SSA_NAME_DEF_STMT (voprnds.last ());
+		  gimple *init_stmt = SSA_NAME_DEF_STMT (voprnds.last ());
 		  gimple_stmt_iterator gsi = gsi_for_stmt (init_stmt);
 		  gsi_insert_seq_before_without_update (&gsi, ctor_seq,
 							GSI_SAME_STMT);
@@ -2611,7 +2611,7 @@ static void
 vect_get_slp_vect_defs (slp_tree slp_node, vec<tree> *vec_oprnds)
 {
   tree vec_oprnd;
-  gimple vec_def_stmt;
+  gimple *vec_def_stmt;
   unsigned int i;
 
   gcc_assert (SLP_TREE_VEC_STMTS (slp_node).exists ());
@@ -2636,7 +2636,7 @@ void
 vect_get_slp_defs (vec<tree> ops, slp_tree slp_node,
 		   vec<vec<tree> > *vec_oprnds, int reduc_index)
 {
-  gimple first_stmt;
+  gimple *first_stmt;
   int number_of_vects = 0, i;
   unsigned int child_index = 0;
   HOST_WIDE_INT lhs_size_unit, rhs_size_unit;
@@ -2660,8 +2660,8 @@ vect_get_slp_defs (vec<tree> ops, slp_tree slp_node,
           child = SLP_TREE_CHILDREN (slp_node)[child_index];
 
 	  /* We have to check both pattern and original def, if available.  */
-	  gimple first_def = SLP_TREE_SCALAR_STMTS (child)[0];
-	  gimple related = STMT_VINFO_RELATED_STMT (vinfo_for_stmt (first_def));
+	  gimple *first_def = SLP_TREE_SCALAR_STMTS (child)[0];
+	  gimple *related = STMT_VINFO_RELATED_STMT (vinfo_for_stmt (first_def));
 
 	  if (operand_equal_p (oprnd, gimple_get_lhs (first_def), 0)
 	      || (related
@@ -2728,14 +2728,14 @@ vect_get_slp_defs (vec<tree> ops, slp_tree slp_node,
    the created stmts must be inserted.  */
 
 static inline void
-vect_create_mask_and_perm (gimple stmt, gimple next_scalar_stmt,
+vect_create_mask_and_perm (gimple *stmt, gimple *next_scalar_stmt,
                            tree mask, int first_vec_indx, int second_vec_indx,
                            gimple_stmt_iterator *gsi, slp_tree node,
                            tree vectype, vec<tree> dr_chain,
                            int ncopies, int vect_stmts_counter)
 {
   tree perm_dest;
-  gimple perm_stmt = NULL;
+  gimple *perm_stmt = NULL;
   stmt_vec_info next_stmt_info;
   int i, stride;
   tree first_vec, second_vec, data_ref;
@@ -2781,7 +2781,7 @@ vect_create_mask_and_perm (gimple stmt, gimple next_scalar_stmt,
    the next vector, i.e., the current first vector is not needed.  */
 
 static bool
-vect_get_mask_element (gimple stmt, int first_mask_element, int m,
+vect_get_mask_element (gimple *stmt, int first_mask_element, int m,
                        int mask_nunits, bool only_one_vec, int index,
 		       unsigned char *mask, int *current_mask_element,
                        bool *need_next_vector, int *number_of_mask_fixes,
@@ -2868,12 +2868,12 @@ vect_transform_slp_perm_load (slp_tree node, vec<tree> dr_chain,
                               gimple_stmt_iterator *gsi, int vf,
                               slp_instance slp_node_instance, bool analyze_only)
 {
-  gimple stmt = SLP_TREE_SCALAR_STMTS (node)[0];
+  gimple *stmt = SLP_TREE_SCALAR_STMTS (node)[0];
   stmt_vec_info stmt_info = vinfo_for_stmt (stmt);
   tree mask_element_type = NULL_TREE, mask_type;
   int i, j, k, nunits, vec_index = 0, scalar_index;
   tree vectype = STMT_VINFO_VECTYPE (stmt_info);
-  gimple next_scalar_stmt;
+  gimple *next_scalar_stmt;
   int group_size = SLP_INSTANCE_GROUP_SIZE (slp_node_instance);
   int first_mask_element;
   int index, unroll_factor, current_mask_element, ncopies;
@@ -3024,7 +3024,7 @@ static bool
 vect_schedule_slp_instance (slp_tree node, slp_instance instance,
                             unsigned int vectorization_factor)
 {
-  gimple stmt;
+  gimple *stmt;
   bool grouped_store, is_store;
   gimple_stmt_iterator si;
   stmt_vec_info stmt_info;
@@ -3083,7 +3083,7 @@ vect_schedule_slp_instance (slp_tree node, slp_instance instance,
   if (STMT_VINFO_GROUPED_ACCESS (stmt_info)
       && REFERENCE_CLASS_P (gimple_get_lhs (stmt)))
     { 
-      gimple last_store = vect_find_last_store_in_slp_instance (instance);
+      gimple *last_store = vect_find_last_store_in_slp_instance (instance);
       if (is_pattern_stmt_p (vinfo_for_stmt (last_store)))
        last_store = STMT_VINFO_RELATED_STMT (vinfo_for_stmt (last_store));
       si = gsi_for_stmt (last_store);
@@ -3111,7 +3111,7 @@ vect_schedule_slp_instance (slp_tree node, slp_instance instance,
 static void
 vect_remove_slp_scalar_calls (slp_tree node)
 {
-  gimple stmt, new_stmt;
+  gimple *stmt, *new_stmt;
   gimple_stmt_iterator gsi;
   int i;
   slp_tree child;
@@ -3178,7 +3178,7 @@ vect_schedule_slp (loop_vec_info loop_vinfo, bb_vec_info bb_vinfo)
   FOR_EACH_VEC_ELT (slp_instances, i, instance)
     {
       slp_tree root = SLP_INSTANCE_TREE (instance);
-      gimple store;
+      gimple *store;
       unsigned int j;
       gimple_stmt_iterator gsi;
 
@@ -3228,7 +3228,7 @@ vect_slp_transform_bb (basic_block bb)
 
   for (si = gsi_start_bb (bb); !gsi_end_p (si); gsi_next (&si))
     {
-      gimple stmt = gsi_stmt (si);
+      gimple *stmt = gsi_stmt (si);
       stmt_vec_info stmt_info;
 
       if (dump_enabled_p ())
